ifndef __ERRNO_INC
define __ERRNO_INC

include libc.inc

ifndef _ERRNO_T_DEFINED
define _ERRNO_T_DEFINED
errno_t typedef sdword
endif

ifndef _CRT_ERRNO_DEFINED
define _CRT_ERRNO_DEFINED
_errno		proto __cdecl
_set_errno	proto __cdecl :int_t
_get_errno	proto __cdecl :ptr int_t
externdef	errno:errno_t
endif

__doserrno	proto __cdecl
_set_doserrno	proto __cdecl :ulong_t
_get_doserrno	proto __cdecl :ptr ulong_t
__sys_errlist	proto __cdecl

externdef	_doserrno:errno_t
externdef	_sys_errlist:array_t
externdef	_sys_nerr:int_t

__sys_nerr	proto __cdecl
_dosmaperr	proto __cdecl :ulong_t
osmaperr	proto __cdecl

ENOERR		equ 0
EPERM		equ 1
ENOENT		equ 2
ESRCH		equ 3
EINTR		equ 4
EIO		equ 5
ENXIO		equ 6
E2BIG		equ 7
ENOEXEC		equ 8
EBADF		equ 9
ECHILD		equ 10
EAGAIN		equ 11
ENOMEM		equ 12
EACCES		equ 13
EFAULT		equ 14
ENOTBLK		equ 15
EBUSY		equ 16
EEXIST		equ 17
EXDEV		equ 18
ENODEV		equ 19
ENOTDIR		equ 20
EISDIR		equ 21
ENFILE		equ 23
EMFILE		equ 24
ENOTTY		equ 25
EFBIG		equ 27
ENOSPC		equ 28
ESPIPE		equ 29
EROFS		equ 30
EMLINK		equ 31
EPIPE		equ 32
EDOM		equ 33
EUCLEAN		equ 35
EDEADLK		equ 36
EUNKNOWN	equ 37
ENAMETOOLONG	equ 38
ENOLCK		equ 39
ENOSYS		equ 40
ENOTEMPTY	equ 41

ifndef _SECURECRT_ERRCODE_VALUES_DEFINED
define _SECURECRT_ERRCODE_VALUES_DEFINED
EINVAL		equ 22
ERANGE		equ 34
EILSEQ		equ 42
STRUNCATE	equ 80
endif

EDEADLOCK	equ EDEADLK

EADDRINUSE	equ 100
EADDRNOTAVAIL	equ 101
EAFNOSUPPORT	equ 102
EALREADY	equ 103
EBADMSG		equ 104
ECANCELED	equ 105
ECONNABORTED	equ 106
ECONNREFUSED	equ 107
ECONNRESET	equ 108
EDESTADDRREQ	equ 109
EHOSTUNREACH	equ 110
EIDRM		equ 111
EINPROGRESS	equ 112
EISCONN		equ 113
ELOOP		equ 114
EMSGSIZE	equ 115
ENETDOWN	equ 116
ENETRESET	equ 117
ENETUNREACH	equ 118
ENOBUFS		equ 119
ENODATA		equ 120
ENOLINK		equ 121
ENOMSG		equ 122
ENOPROTOOPT	equ 123
ENOSR		equ 124
ENOSTR		equ 125
ENOTCONN	equ 126
ENOTRECOVERABLE equ 127
ENOTSOCK	equ 128
ENOTSUP		equ 129
EOPNOTSUPP	equ 130
EOTHER		equ 131
EOVERFLOW	equ 132
EOWNERDEAD	equ 133
EPROTO		equ 134
EPROTONOSUPPORT equ 135
EPROTOTYPE	equ 136
ETIME		equ 137
ETIMEDOUT	equ 138
ETXTBSY		equ 139
EWOULDBLOCK	equ 140

define ERROR_INVALID_FUNCTION		1
define ERROR_FILE_NOT_FOUND		2
define ERROR_PATH_NOT_FOUND		3
define ERROR_TOO_MANY_OPEN_FILES	4
define ERROR_ACCESS_DENIED		5
define ERROR_INVALID_HANDLE		6
define ERROR_ARENA_TRASHED		7
define ERROR_NOT_ENOUGH_MEMORY		8
define ERROR_INVALID_BLOCK		9
define ERROR_BAD_ENVIRONMENT		10
define ERROR_BAD_FORMAT			11
define ERROR_INVALID_ACCESS		12
define ERROR_INVALID_DATA		13
define ERROR_OUTOFMEMORY		14
define ERROR_INVALID_DRIVE		15
define ERROR_CURRENT_DIRECTORY		16
define ERROR_NOT_SAME_DEVICE		17
define ERROR_NO_MORE_FILES		18
define ERROR_WRITE_PROTECT		19
define ERROR_BAD_UNIT			20
define ERROR_NOT_READY			21
define ERROR_BAD_COMMAND		22
define ERROR_CRC			23
define ERROR_BAD_LENGTH			24
define ERROR_SEEK			25
define ERROR_NOT_DOS_DISK		26
define ERROR_SECTOR_NOT_FOUND		27
define ERROR_OUT_OF_PAPER		28
define ERROR_WRITE_FAULT		29
define ERROR_READ_FAULT			30
define ERROR_GEN_FAILURE		31
define ERROR_SHARING_VIOLATION		32
define ERROR_LOCK_VIOLATION		33
define ERROR_WRONG_DISK			34
define ERROR_SHARING_BUFFER_EXCEEDED	36
define ERROR_HANDLE_EOF			38
define ERROR_HANDLE_DISK_FULL		39
define ERROR_NOT_SUPPORTED		50
define ERROR_BAD_NETPATH		53
define ERROR_NETWORK_ACCESS_DENIED	65
define ERROR_BAD_NET_NAME		67
define ERROR_FILE_EXISTS		80
define ERROR_CANNOT_MAKE		82
define ERROR_FAIL_I24			83
define ERROR_INVALID_PARAMETER		87
define ERROR_NO_PROC_SLOTS		89
define ERROR_DRIVE_LOCKED		108
define ERROR_BROKEN_PIPE		109
define ERROR_DISK_FULL			112
define ERROR_INVALID_TARGET_HANDLE	114
define ERROR_WAIT_NO_CHILDREN		128
define ERROR_CHILD_NOT_COMPLETE		129
define ERROR_DIRECT_ACCESS_HANDLE	130
define ERROR_NEGATIVE_SEEK		131
define ERROR_SEEK_ON_DEVICE		132
define ERROR_DIR_NOT_EMPTY		145
define ERROR_NOT_LOCKED			158
define ERROR_BAD_PATHNAME		161
define ERROR_MAX_THRDS_REACHED		164
define ERROR_LOCK_FAILED		167
define ERROR_ALREADY_EXISTS		183
define ERROR_INVALID_STARTING_CODESEG	188
define ERROR_INFLOOP_IN_RELOC_CHAIN	202
define ERROR_FILENAME_EXCED_RANGE	206
define ERROR_NESTING_NOT_ALLOWED	215
define ERROR_NOT_ENOUGH_QUOTA		1816

endif
